﻿Public Class Form1
    Dim time_interval As Short
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.NotifyIcon1.Visible = True
        Dim filepath As String
        filepath = Application.StartupPath + "\Confile.ini" '当前应用程序所在的路径
        'Application.ExecutablePath '当前应用程序全路径
        If My.Computer.FileSystem.FileExists(filepath) Then '判断配置文件是否存在
            TextBox_URL.Text = GetINI("CONFIG", "URL", "", filepath) '获取请求网址
            TextBox_timeinterval.Text = GetINI("CONFIG", "timeinterval", "", filepath) '获取监控时间间隔
            CheckBox1.CheckState = GetINI("CONFIG", "Check", "", filepath) '是否开机启动
        End If
        WebBrowser1.ScriptErrorsSuppressed = True '屏蔽脚本错误提示
        WebBrowser1.AllowWebBrowserDrop = False '不接受拖放到它上面的文档
        WebBrowser1.WebBrowserShortcutsEnabled = False '屏蔽键盘快捷键
        WebBrowser1.IsWebBrowserContextMenuEnabled = False '屏蔽快捷菜单
        WebBrowser1.Navigate(TextBox_URL.Text) '打开请求网址
    End Sub
    Private Sub Form1_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        '点击X号，保存配置并最小化
        Dim filepath As String
        filepath = Application.StartupPath + "\Confile.ini"
        WriteINI("CONFIG", "URL", TextBox_URL.Text, filepath) '请求网址
        WriteINI("CONFIG", "timeinterval", TextBox_timeinterval.Text, filepath) '监控时间间隔
        WriteINI("CONFIG", "Check", CStr(CheckBox1.CheckState), filepath) '是否开机启动
        e.Cancel = True
        Me.Hide()
    End Sub
    Private Sub Button_test_Click(sender As Object, e As EventArgs) Handles Button_test.Click
        If (WebBrowser1.Document IsNot Nothing) Then
            Dim Elems As HtmlElementCollection
            Dim WebOC As WebBrowser = WebBrowser1
            Elems = WebOC.Document.GetElementsByTagName("div") '取出源码中所有div
            For Each elem As HtmlElement In Elems
                Dim NameStr As String = elem.GetAttribute("id") '取出div中所有id
                If ((NameStr IsNot Nothing) And (NameStr.Length <> 0)) Then
                    Dim leftString = Mid(NameStr, 1, 10) '取id前面10位数
                    If leftString.ToLower().Equals("magicdomid") Then
                        Dim ContentStr = WebBrowser1.Document.GetElementById(NameStr).InnerText '读取当前指令
                        If ContentStr <> "" Then
                            MessageBox.Show("当前远端指令为：" + ContentStr)
                        End If
                    End If
                End If
            Next
        End If
    End Sub

    '声明INI配置文件读写API函数
    Private Declare Function GetPrivateProfileString Lib "kernel32" Alias "GetPrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Int32, ByVal lpFileName As String) As Int32
    Private Declare Function WritePrivateProfileString Lib "kernel32" Alias "WritePrivateProfileStringA" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Int32
    '定义读取配置文件函数
    Public Function GetINI(ByVal Section As String, ByVal AppName As String, ByVal lpDefault As String, ByVal FileName As String) As String
        Dim Str As String = LSet(Str, 256)
        GetPrivateProfileString(Section, AppName, lpDefault, Str, Len(Str), FileName)
        Return Microsoft.VisualBasic.Left(Str, InStr(Str, Chr(0)) - 1)
    End Function
    '定义写入配置文件函数
    Public Function WriteINI(ByVal Section As String, ByVal AppName As String, ByVal lpDefault As String, ByVal FileName As String) As Long
        WriteINI = WritePrivateProfileString(Section, AppName, lpDefault, FileName)
    End Function
    Private Sub Button_Save_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button_Save.Click
        Try
            Dim filepath As String
            filepath = Application.StartupPath + "\Confile.ini"
            WriteINI("CONFIG", "URL", TextBox_URL.Text, filepath) '请求网址
            WriteINI("CONFIG", "timeinterval", TextBox_timeinterval.Text, filepath) '监控时间间隔
            WriteINI("CONFIG", "Check", CStr(CheckBox1.CheckState), filepath) '是否开机启动
            'Me.Hide()
            MsgBox("配置保存成功！")
            'Me.Close()
        Catch ex As Exception
            MsgBox("错误！！！")
        End Try
    End Sub
    Private Sub NotifyIcon1_MouseClick(sender As Object, e As MouseEventArgs) Handles NotifyIcon1.MouseClick
        '单击托盘图标显示窗口
        Me.Show()
        Me.WindowState = FormWindowState.Normal
        TopMost = True '先把窗口置于顶层
        TopMost = False '取消置顶
    End Sub
    Private Sub Timer1_Tick(sender As Object, e As EventArgs) Handles Timer1.Tick
        time_interval += 1
        If time_interval = Val(TextBox_timeinterval.Text) Then
            If (WebBrowser1.Document IsNot Nothing) Then
                Dim Elems As HtmlElementCollection
                Dim WebOC As WebBrowser = WebBrowser1
                Elems = WebOC.Document.GetElementsByTagName("div") '取出源码中所有div
                For Each elem As HtmlElement In Elems
                    Dim NameStr As String = elem.GetAttribute("id") '取出div中所有id
                    If ((NameStr IsNot Nothing) And (NameStr.Length <> 0)) Then
                        Dim leftString = Mid(NameStr, 1, 10) '取id前面10位数
                        If leftString.ToLower().Equals("magicdomid") Then
                            Dim ContentStr = WebBrowser1.Document.GetElementById(NameStr).InnerText '读取当前指令
                            If ContentStr = TextBox_instruction.Text Then
                                '关机
                                Shell("shutdown.exe -s -t 10 -c 10秒钟后关机，请保存好文件") '-t是延迟时间，0表示立刻关机
                                '结束应用程序
                                End
                            End If
                        End If
                    End If
                Next
            End If
            time_interval = 0
        End If
    End Sub
    Private Sub TextBox_URL_TextChanged(sender As Object, e As EventArgs) Handles TextBox_URL.TextChanged
        WebBrowser1.Navigate(TextBox_URL.Text) '打开请求网址
    End Sub
End Class
